//Functions respectivly procedures are not available on global layer exspect of casting operations and functions
const int SCRIPT_GAME_VERSION = int(0x000400);
const int CONST_MINE_COUNT = 8;
const float CONST_MINE_DEEP = 1.5;
const float CONST_MINE_HEIGHT = 0.25;
const float CONST_ROV = 5.0;
const float CONST_UI_TEXTFADE = 0.1;
const uint CONST_UI_MINEWARN = 2000;
const float CONST_MINEWARN_MAX = 1.5;
const float CONST_DEATHLINE = -1;
const float CONST_STARTLINE = 5;
PhysicsObject *playerHead,*startArea,*finishArea;
UIFont *fontMed,*fontSmall;
uint finishMode,overheadTitleLast,subHeaderLast,overheadTitleDur,subHeaderDur,msstarted,msplayed = 0,
	timepassed = 0;
bstr overheadTitle,subHeaderTitle,subHeaderSubTitle;
bool playing = false;
float SCREEN_HEIGHT,SCREEN_MIDDLE,SCREEN_CENTER,overheadTitleAlpha = 0,
	subHeaderAlpha = 0;
void onInit( )
{	
	int mineXPos,i;
	PhysicsObject *mine;
	for( i = 1; i <= CONST_MINE_COUNT; i++ )
	{
		mine = findObject( "mine" + bstrFormat( i ) );
		mineXPos = rand( 48 )+ 5;
		mine->setSize( CONST_MINE_DEEP,CONST_MINE_DEEP,CONST_MINE_HEIGHT );
		mine->setPosition( float( mineXPos ),float( rand( 6 )- 3 ),getZPos( mineXPos )+ CONST_MINE_HEIGHT/2 );
		mine->setRotation( 0,0,getRoll( mineXPos ) );
	};
	SCREEN_HEIGHT =	float( getScreenHeight( ) );
	SCREEN_MIDDLE = float( getScreenWidth( )/2 );
	SCREEN_CENTER = float( SCREEN_HEIGHT/2 );
	setGravity( 0,0,-0.5 );
	setClearColor( 0.4,0.4,0.65 );
	finishMode = 0;
	fontMed = getFont( "medium" );
	fontSmall = getFont( "small" );
	playerHead = findObject( "Head" );
	startArea = findObject( "startArea" );
	finishArea = findObject( "finishArea" );
	playerHead->setColor( 0.2,0.15,0.05 );
	findObject( "Neck" )->setColor( 0.2,0.15,0.05 );
	findObject( "Trunk" )->setColor( 0.2,0.3,0 );
	findObject( "LeftForearm" )->setColor( 0.2,0.25,0 );
	findObject( "RightForearm" )->setColor( 0.2,0.25,0 );
	findObject( "LeftThigh" )->setColor( 0.2,0.25,0 );
	findObject( "RightThigh" )->setColor( 0.2,0.25,0 );
	findObject( "LeftArm" )->setColor( 0.25,0.35,0 );
	findObject( "RightArm" )->setColor( 0.25,0.35,0 );
	findObject( "LeftCalf" )->setColor( 0.25,0.35,0 );
	findObject( "RightCalf" )->setColor( 0.25,0.35,0 );
	findObject( "LeftFoot" )->setColor( 0.1,0,0 );
	findObject( "RightFoot" )->setColor( 0.1,0,0 );
	setOverheadTitle( "Sleeper's minefield - Welcome",5000 );
}
void onUpdate( uint time )
{		
	int i;
	float mineXPos,mineYPos,mineZPos,redApply,playerXPos,playerYPos,playerZPos;
	PhysicsObject *mine;	
	for( i = 1; i <= CONST_MINE_COUNT; i++ )
	{
		mine = findObject( "mine" + bstrFormat( i ) );
		redApply = -0.75/CONST_ROV*getDistance( playerHead,mine )+ 0.75;
		if( getDistance( playerHead,mine )<( CONST_MINEWARN_MAX + CONST_MINE_DEEP ) && getGameState( )== GAMESTATE_RUNNING )
			setSubHeader( "OH SHIT !","That came too close some of those...",2000 );
		if( redApply < 0 || !playing)
			redApply = 0;
		mine->setColor( 0.25 + redApply,0.4,0.1 );
	}
	playerHead->getPosition( playerXPos,playerYPos,playerZPos );
	if( playerZPos < CONST_DEATHLINE )
	{
		setSubHeader( "STICK ARROUND !","The mines want you back",10000 );
		playing = false;
		setGameState( GAMESTATE_ABORTED );
	}
	if( playerXPos > CONST_STARTLINE && getGameState( ) == GAMESTATE_RUNNING && !playing )
	{
		setSubHeader( "GO !","Make it without getting blasted",5000 );
		playing = true;
		msstarted = time;
	}
	timepassed = time;
	if( playing && getGameState( ) == GAMESTATE_RUNNING )
		msplayed = time - msstarted;
}
bool onCollision( PhysicsObject *objectA, PhysicsObject *objectB )
{
	if( objectA->getType( ) == PHYSOBJ_RAGDOLL_BODY || objectB->getType( ) == PHYSOBJ_RAGDOLL_BODY )
	{
		PhysicsObject *nonPlayerObj;
		if( objectA->getType( ) == PHYSOBJ_RAGDOLL_BODY )
			nonPlayerObj = objectB;
		else
			nonPlayerObj = objectA;
		if( isNamedMine( nonPlayerObj ) )
		{
			setSubHeader( "MINE HIT - TRAPPED","You messed it up",10000 );
			setGameState( GAMESTATE_ABORTED );
		}
		if( nonPlayerObj == finishArea )
		{
			setSubHeader( "FINISH","You did it trough the war",10000 );
			setGameState( GAMESTATE_FINISHED );
		}
	}
	return false;
}
void onRender( )
{
	drawOverheadTitle( );
	drawSubHeader( );
	fontSmall->drawString( 20,20,UIFONT_ALIGN_DEFAULT,"You run for " + bstrFormat( int( floor( double( msplayed )/1000 ) ) )+ ":" + bstrFormat( msplayed % 1000 ),1,1,1,1 );
}
float getZPos( int XPos )
{
	if( XPos <= 25 )
		return 0.25;
	if( XPos <= 27 )
		return( ( float( XPos )- 25 )*0.5 + 0.25 );
	if( XPos <= 33 )
		return 1.25;
	if( XPos <= 37 )
		return( ( float( XPos )- 33 )*-0.5 + 1.25 );
	return -0.75;
}
float getRoll( int XPos )
{
	if( XPos <= 25 )
		return 0;
	if( XPos <= 27 )
		return float( atan( 0.5 ) );
	if( XPos <= 33 )
		return 0;
	if( XPos <= 37 )
		return float( -atan( 0.5 ) );
	return 0;
}
bool isNamedMine( PhysicsObject *object )
{
	bstr objectName = object->getName( );
	if( objectName[ 0 ] == int( 0x6D )&&
		objectName[ 1 ] == int( 0x69 )&&
		objectName[ 2 ] == int( 0x6E )&&
		objectName[ 3 ] == int( 0x65 ) )
		return true;
	else
		return false;
}
int rand( int maxRand )
{
	return( randomInt( )%maxRand );
}
float getDistance( PhysicsObject *objectA,PhysicsObject *objectB )
{
	float objectAx = 0,
		objectAy = 0,
		objectAz = 0,
		objectBx = 0,
		objectBy = 0,
		objectBz = 0;
	double dx,dy,dz;
	objectA->getPosition( objectAx,objectAy,objectAz );
	objectB->getPosition( objectBx,objectBy,objectBz );
	dx = double( objectBx - objectAx );
	dy = double( objectBy - objectAy );
	dz = double( objectBz - objectAz );
	return float( sqrt( pow( dx,2 )+ pow( dy,2 )+ pow( dz,2 ) ) );
}
void setSubHeader( bstr set_subHeaderTitle,bstr set_subHeaderSubTitle,uint set_subHeaderDur )
{
	if( set_subHeaderTitle == "" && set_subHeaderSubTitle == "" )
		subHeaderDur = 0;
	subHeaderTitle = set_subHeaderTitle;
	subHeaderSubTitle = set_subHeaderSubTitle;
	subHeaderAlpha = 1;
	subHeaderLast = timepassed;
	subHeaderDur = set_subHeaderDur;
}
void drawSubHeader( )
{
	if( ( timepassed - subHeaderLast )> subHeaderDur )
		if( subHeaderAlpha - CONST_UI_TEXTFADE >= 0 )
			subHeaderAlpha -= CONST_UI_TEXTFADE;
		else
			subHeaderAlpha = 0;
	fontMed->drawString( SCREEN_MIDDLE,SCREEN_HEIGHT - 90,UIFONT_ALIGN_HORIZ_CENTER,subHeaderTitle,0.4,0.3,0,subHeaderAlpha );
	fontSmall->drawString( SCREEN_MIDDLE,SCREEN_HEIGHT - 90 + float( fontMed->getFontHeight( )+ 10 ),UIFONT_ALIGN_HORIZ_CENTER,subHeaderSubTitle,0.2,0.3,0,subHeaderAlpha );
}
void setOverheadTitle( bstr set_overheadTitle,uint set_overheadTitleDur )
{
	if( set_overheadTitle == "" )
		overheadTitleDur = 0;
	overheadTitle = set_overheadTitle;
	overheadTitleAlpha = 1;
	overheadTitleLast = timepassed;
	overheadTitleDur = set_overheadTitleDur;
}
void drawOverheadTitle( )
{
	if( ( timepassed - overheadTitleLast )> overheadTitleDur )
		if( overheadTitleAlpha - CONST_UI_TEXTFADE >= 0 )
			overheadTitleAlpha -= CONST_UI_TEXTFADE;
		else
			overheadTitleAlpha = 0;
	fontMed->drawString( SCREEN_MIDDLE,20,UIFONT_ALIGN_HORIZ_CENTER,overheadTitle,0.4,0.3,0,overheadTitleAlpha );
}